/*
 * qemu_agent_aux.h: provides streams for guest commands
 *
 * Copyright (C) 2020 Parallels International GmbH
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#pragma once

# include "internal.h"
# include "domain_conf.h"

typedef struct _qemuAgentAux qemuAgentAux;

typedef void (*qemuAgentAuxErrorCallback)(qemuAgentAux *mon, virDomainObj *vm);

qemuAgentAux *qemuAgentAuxOpen(virDomainObj *vm,
                               int fd,
                               GMainContext *context,
                               qemuAgentAuxErrorCallback cb);

void qemuAgentAuxClose(qemuAgentAux *mon);

int qemuAgentAuxOpenStream(qemuAgentAux *mon,
                           virStreamPtr st,
                           bool rx);

void
qemuAgentAuxNotifyTermination(qemuAgentAux *mon);
